#!/usr/bin/perl -w

# must be run from within project directory. E.g. ~/projects/cplan

# ./create_test_work.pl -numwu 10 -batch 0 -label "lowpri"
# ./create_test_work.pl -numwu 5 -batch 1 -label "highpri"

# ./create_test_work.pl -numwu 5 -batch 1 -label "lowpri"
# ./create_test_work.pl -numwu 5 -batch 1 -label "highpri" -assign

# ./bin/create_work -appname 'uppercase' -wu_name
# 'wucloud_asgn_five' -wu_template 'templates/uc_wu'
# -result_template 'templates/uc_result' --assign_cloud_one 1 in


# http://localhost/cplan_ops/assign_batch_to_cloud.php?batch=1


use DBI;
use strict;

sub main();
sub create_wu($$$$$);
sub extract_parameters();
use Getopt::Long;

main;

sub main(){

    

    my ($numwu, $batch, $label, $assign) = extract_parameters();
    my ($dsn, $user, $password, $dbh, $sth, $i, $db);

    $db = "boinc_stp_db";

    $dsn = "DBI:mysql:$db:localhost";
    $user = "boincadm";
    $password = "edgi";
    
    
# Connecting is exppensive.
# Auto commit so that changes are automatically saved when executed
    $dbh = DBI->connect ($dsn, $user, $password,
                         { PrintError => 1, RaiseError => 1, AutoCommit => 0 });
    
    
    print "# of workunits to create: ", $numwu, "\n\n";
    
    for ($i=0; $i<$numwu; $i++){

        $sth = $dbh->prepare ("SELECT MAX(id) FROM workunit");
        
        create_wu($sth, $i, $batch, $label, $assign);
        
    }

# reload the feeder
    if ($assign){

        system ('touch reread_db');
    }

    $dbh->disconnect;

}

sub create_wu ($$$$$){
    my ($sth, $i, $batch, $label, $assign) = @_;

    my ($new_id, $id, $cmd);

    $sth->execute();
    
    while (my @row = $sth->fetchrow_array){
        $id = $row[0];
    }
    
    $id=1000 if not defined($id);

    $new_id = $id + 1 + $i;
    
    my ($wu_name) = "testwu" . (defined($label)?
                                "_${label}_": "")
        . ($assign? "_asgn_": "") . $new_id; 


    my($batch_flag) =  ($batch? "-batch $batch": "");
    my ($asgn_flag) = ($assign? "--assign_cloud_one 1": "");

    
# put input file in the hierarchical directory
    my($download_path) = qx(./bin/dir_hier_path in);
    chomp($download_path);

    if (!(-e $download_path)){
        print "download path = $download_path\n";
    	if (!(-e "in")){
	    system("echo 'Dummy input file' > in")
	}	
        $cmd = "cp in $download_path";
        print $cmd, "\n";
        system($cmd) == 0 or die "cp failed";
    }

    print "new wu name: $wu_name, wu id: $new_id, batch: $batch, label: " . (defined($label)? $label : "") . "\n";

    $cmd = "./bin/create_work -appname 'uppercase' -wu_name $wu_name -wu_template 'templates/uc_wu' -result_template templates/uc_result --min_quorum 1 $batch_flag $asgn_flag in";

    print $cmd, "\n\n";

    system("$cmd") == 0 or die "$cmd failed";

}


sub extract_parameters()
{
	my %params = (
		numwu => \(my $numwu = undef),
        batch => \(my $batch = undef), 
        label => \(my $label = undef), 
        assign => \(my $assign = 0), 
	);

	# Call Library function which will extract and remove all switches and
	# their corresponding values.
	# These parameters will be removed from @ARGV

	my $errorval = &GetOptions(\%params, "numwu=s", "db=s",
                               "batch=s", "label=s",
                               "assign!");
                        # the exclaimation point allows for the negation
                        # of the switch (i.e. -nobackup/-nobody is a switch)

	# Error value should have returned 1 if nothing went wrong
	# Otherwise, an unlisted parameter was specified.
	if($errorval !=1)
	{
		# Expecting GetOptions to state error.

		print "Exiting Program...\n";
		exit 0;
	}

	#if(!(defined ($db))){
	#    $db = "boinc_stp_db";
	#}

	if(!(defined ($numwu))){
	    $numwu = "1";
	}

	if(!(defined ($batch))){
	    $batch = "0";
	}

	if(!(defined ($label))){
	    $label = undef;
	}

	return ($numwu, $batch, $label, $assign);
	
}
