#! /usr/bin/python


"""//Web to administrate scheduler resources//
 
- > This Web service can be use to register the cloud resources available to the scheduler.
 
- File: admin_cloud.py

- Notes: 
 - A database configuration file named "db.cfg" must be present in the directory.

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import db_func
from tools import cgi_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)

cgi_func.print_header()

if not cgi_func.get_form_value('del') is None:
    try: 
        n = int(cgi_func.get_form_value('del'))
    except Exception as e:
        print "<p>Error during deletion</p>"
        print "<p>%s</p>" % e
    else:    
        print "<p>Deleting cloud worker %d</p>" % n

        conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
        c=conn.cursor()
        try:
            c.execute("DELETE FROM CloudWorkers WHERE cloud_worker_id=%d" % n)
        except db_func.DBError as e:
            log.error("Error during the SQL command execution !")
            log.error(e)
        db_func.disconnect(conn)
    
        print "<p>Cloud Worker Deleted</p>" 
    print "<p> <a href='admin_cloud.py'>Go back</a></p>"

elif (cgi_func.get_form_value('Cloud_Worker_Technology') is None):
    
    print "<p>Register a new cloud worker (currently only 'EC2' or 'EUCA' is supported)</p>"
    cgi_func.print_form(['Cloud_Worker_Technology'])

    print "<p>Cloud worker already registered:</p><table border=1>"
    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("SELECT cloud_worker_id, cloud_tech FROM CloudWorkers")
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    res=c.fetchall()
    db_func.disconnect(conn)
    
    print "<tr><td>id</td><td>Cloud Worker Technology</td></tr>" 

    for l in res:
        print "<tr><td>%d</td><td>%s</td><td><a href=admin_cloud.py?del=%s>Delete</a></td>" \
            % (l[0],l[1],l[0]) 

    print "</table>"

else:
    cw_tech = cgi_func.get_form_value('Cloud_Worker_Technology')

    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("INSERT CloudWorkers(cloud_tech,cloud_host,cloud_worker_data,batch_id) VALUES ('%s','None','','None')" % (cw_tech))
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    db_func.disconnect(conn)
    print "<p> Cloud Worker registered !</p>"
    print "<p> <a href='admin_cloud.py'>Go back</a></p>"

cgi_func.print_footer()

