#! /usr/bin/python

"""Unit tests for calculate_cloud_benefit.py

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
sys.path.append(os.path.join(sys.path[0],"..",".."))
os.chdir(os.path.join(sys.path[0],".."))

from tools import db_func
from monitor_cloud_workers import monitor_cloud_workers
import unittest
import random


class BadArgument(unittest.TestCase):
    """Test for bad arguments

    
    """

    def testWrongDBConn(self):
        conn=db_func.connect(db_func.read_db_config("../info/db.cfg"))
        self.assertEqual(monitor_cloud_workers(conn), None)
        db_func.disconnect(conn)

    def testNoDBConn(self):
        self.assertEqual(monitor_cloud_workers(None), None)


class BadReturn(unittest.TestCase):
    """Test for bad returned values
    
    """
    pass


class ConsistencyCheck(unittest.TestCase):
    """Test consistency
    
    """
    pass
    
    
    
            
if __name__ == "__main__":
    unittest.main()   
